﻿# Current Directory Game Files (Steam)
$InstallLocation_Steam = Get-ItemPropertyValue "HKLM:\Software\Microsoft\Windows\CurrentVersion\Uninstall\Steam App 261550" -name "InstallLocation" -ErrorAction SilentlyContinue
$DisplayName_Steam = Get-ItemPropertyValue "HKLM:\Software\Microsoft\Windows\CurrentVersion\Uninstall\Steam App 261550" -name "DisplayName" -ErrorAction SilentlyContinue

# Current Directory Game Files (GOG)
$InstallLocation_GOG = Get-ItemPropertyValue "HKLM:\SOFTWARE\WOW6432Node\Microsoft\Windows\CurrentVersion\Uninstall\1564781494_is1" -name "InstallLocation" -ErrorAction SilentlyContinue
$DisplayName_GOG = Get-ItemPropertyValue "HKLM:\SOFTWARE\WOW6432Node\Microsoft\Windows\CurrentVersion\Uninstall\1564781494_is1" -name "DisplayName" -ErrorAction SilentlyContinue

# ErrorMessage Reset
$ErrorMessage = $null

# Object Forms
Add-Type -AssemblyName System.Windows.Forms

# Check Admin Mode
$currentPrincipal = New-Object Security.Principal.WindowsPrincipal([Security.Principal.WindowsIdentity]::GetCurrent())
$ADMIN = $currentPrincipal.IsInRole([Security.Principal.WindowsBuiltInRole]::Administrator)

if ($ADMIN -eq "True")
    {
    # Game not found. Select directory
    if (-not(($DisplayName_Steam -eq "Mount & Blade II: Bannerlord") -or ($DisplayName_GOG -eq "Mount & Blade II: Bannerlord"))) 
        {
        cls
        "###########################"
        "# MODULE UNBLOCK DDL v1.4 #"
        "###########################"
        ""
        "This script could not find the location of the game. Please select directory game."
        ""
        $browser = New-Object System.Windows.Forms.FolderBrowserDialog
        $null = $browser.ShowDialog()
        $path = $browser.SelectedPath

        $Boolean_String_Empty_Path = [string]::IsNullOrWhitespace($path)
        if ($Boolean_String_Empty_Path -eq $True) 
            {
            exit
            }

        else
            {
            # Check .exe launch Game
            if (Get-ChildItem "$path\bin\Win64_Shipping_Client\TaleWorlds.MountAndBlade.Launcher.exe" -ErrorAction SilentlyContinue)
                {
                $GAME_CUSTOM_ROOT_DETECT = $path
                }
            }
        }

    # Check if directory Game Found
    if (($DisplayName_Steam -eq "Mount & Blade II: Bannerlord") -or ($DisplayName_GOG -eq "Mount & Blade II: Bannerlord") -or ($GAME_CUSTOM_ROOT_DETECT -ne $null))
        {
        cls
        "###########################"
        "# MODULE UNBLOCK DDL v1.4 #"
        "###########################"
        ""
        "File being checked. Please wait..."      
        
        $AllFolders = $null
        if ($DisplayName_Steam -eq "Mount & Blade II: Bannerlord") {$AllFolders += Get-ChildItem "$InstallLocation_Steam\Modules" -directory -recurse | Where { (Get-ChildItem $_.fullName).count -ge 1 }}
        if ($DisplayName_GOG -eq "Mount & Blade II: Bannerlord") {$AllFolders += Get-ChildItem "$InstallLocation_GOG\Modules" -directory -recurse | Where { (Get-ChildItem $_.fullName).count -ge 1 }}
        if ($GAME_CUSTOM_ROOT_DETECT -ne $null) {$AllFolders += Get-ChildItem "$GAME_CUSTOM_ROOT_DETECT\Modules" -directory -recurse | Where { (Get-ChildItem $_.fullName).count -ge 1 }}

        $FilesBlocked = @()
        foreach ($Folder in $AllFolders)
            {
            $CurrentDirectory = $Folder.Fullname
            try
                {
                $FilesBlocked += @((Get-Item $CurrentDirectory\* -Stream zone* -ErrorAction Stop).FileName)
                }
            catch
                {
                $ErrorMessage += @($_.Exception.Message)
                }
            }

        $Boolean_String_Empty_FilesBlocked = [string]::IsNullOrWhitespace($FilesBlocked)
        if ($Boolean_String_Empty_FilesBlocked -eq $False)
            {
            try
                {
                foreach ($File in $FilesBlocked)
                    {
                    if ($File -match "[A-Z]")
                        {
                        Unblock-File $File
                        }
                    }
                }
            catch
                {
                $ErrorMessage += @($_.Exception.Message)
                }
            }

        else
            {
            cls
            "###########################"
            "# MODULE UNBLOCK DDL v1.4 #"
            "###########################"
            ""
            "No files currently locked. Everything ok"
            ""
            pause
            exit
            }

        if ($ErrorMessage -match "[A-Z]")
            {
            cls
            "###########################"
            "# MODULE UNBLOCK DDL v1.4 #"
            "###########################"
            ""
            "Impossible unblock this dll(s) file(s) :"
            $ErrorMessage
            ""
            pause
            exit
            }
        
        else
            {
            cls
            "###########################"
            "# MODULE UNBLOCK DDL v1.4 #"
            "###########################"
            ""
            "Scrit successfully unblocked the files below : "
            $FilesBlocked
            ""
            pause
            exit
            }

        }

    else
        {
        cls
        "###########################"
        "# MODULE UNBLOCK DDL v1.4 #"
        "###########################"
        ""
        "This script could not find the location of the game. Please verify that your game is installed correctly."
        ""
        pause
        exit
        }
    }
else
    {
    cls
    "###########################"
    "# MODULE UNBLOCK DDL v1.4 #"
    "###########################"
    ""
    "This script was not launched as an administrator. Please verify that your Windows account has administrator rights."
    ""
    pause
    exit
    }
